const { LogicEngine, AsyncLogicEngine } = require('.')
const { Override } = require('./constants')
const Yield = require('./structures/Yield')
const logic = new LogicEngine(undefined, { yieldSupported: true })

const mock = {}

function timeout (n) {
  return new Promise(resolve => {
    setTimeout(() => {
      resolve()
    }, n)
  })
}

function getData (input) {
  const [a, created] = input
  if (!created) {
    setTimeout(() => {
      mock[a] = 7
    }, 3000)
  }
  if (!mock[a]) {
    return new Yield({ _input: [a, true] })
  }
  console.log(mock[a])
  return mock[a]
}

logic.addMethod('yeet', getData, { yields: true })

async function main () {
  console.time('a')
  const f = logic.build({ '+': [{ var: '' }, { yeet: ['a'] }] })
  const a = { yield1_input: ['a', true] }
  for (let i = 0; i < 2.0e5; i++) {
    try {
      f(5, a)
    } catch (err) {

    }
  }
  console.timeEnd('a')
}

main()
