const { LogicEngine } = require('.')

const x = new LogicEngine()

x.addMethod('base64_encode', i => {
  return Buffer.from(i).toString('base64')
})

x.addMethod('base64_decode', i => {
  return Buffer.from(i, 'base64').toString()
})

function repeat (name, times, func) {
  console.time(name)
  for (let i = 0; i < times; i++) { func(i) }
  console.timeEnd(name)
}

repeat('Base64 Encode', 1e6, x.build({
  base64_decode: { base64_encode: { cat: ['Hello,', { var: '' }] } }
}))

repeat('Base64 Manual', 1e6, (i) => {
  return Buffer.from(Buffer.from('Hello, ' + i).toString('base64'), 'base64').toString()
})
